{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Базовый модуль библиотеки.
    Базовый класс, функции инициализации-завершения,
    набор предопределенных variant-переменных.

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$SMARTLINK ON}
{$mode objfpc}
{$H+}
unit uev3;

interface
 uses cthreads,variants;

// звуковые сигналы, которые могут использоваться в ev3init()
 const signal1='-f 500 -l 100 -n -f 600 -l 100 -n -f 1500 -l 100 -n -f 1000 -l 100';
       signal2='-f 1000 -l 100 -n -f 1500 -l 100 -n -f 600 -l 100 -n -f 500 -l 100';
       signal3='-f523.251 -l100 -D100 -n -f391.995 -l100 -D100 -n -f329.628 -l100 -D100 -n -f261.626 -l200';
       signal4='-f261.626 -l200 -n -f329.628 -l100 -D100 -n -f391.995 -l100 -D100 -n -f523.251 -l100 -D100';
       signal5='-f165.4064 -l100 -n -f130.813 -l100 -n -f261.626 -l100 -n -f523.251 -l100 -n -f1046.50 -l100 -n -f2093.00  -l100 -n  -f4186.01 -l100';



var
 // ms - время слипа в режиме ожидания события
 waitInterval:word=10;

type
  TEv3EventLink=(evAND,evOR);

  { TEv3 }

  TEv3=class
   private
    ftimers:array[0..9]of TDateTime;
   public
    constructor Create;
    class function varToYes(yes:variant):boolean;
    {
     метод ожидания (блокировки) возникновения некоторого события
     возвращает истину при достижении события и ложь при достижения таймаута
     таймаут - в миллисекундах, при таймауте=0 - однократная проверка достижения
     В классе TEv3 - заглушка, должен перекрываться в потомках, которые нуждаются в
     механизмах ожидания событий
    }
    function waitEvent(event:ansistring; timeout:dword=high(dword)):boolean; virtual; // abstract;
    {
     метод ожидания возникновения событий на ВСЕХ переданых переданных объектах
     Параметры передаются парами: объект-событие
    }
    function waitAllEvents(objs:array of const; timeout:dword=high(dword)):boolean;
    {
     метод ожидания возникновения события на ХОТЯ-БЫ НА ОДНОМ ИЗ переданных объектов
     Параметры передаются парами: объект-событие
     Если событие возникло, возвращает первый объект, где оно возникло, иначе nil
    }
    function waitAnyEvent(objs:array of const; timeout:dword=high(dword)):TEv3;
    {
     универсальное ожидание
    }
    function waitEvents(Args:array of const; eLink:TEv3EventLink; out res:TEv3; timeout:dword=high(dword)):boolean;
    function waitEvents(Objs: array of TEv3; Events: array of string;
      eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
    // v0.2
    {
     блокирует на ms миллисекунд
    }
    function sleep(ms:dword):TEv3;
    {
     запускает таймер, количество таймеров - 10, с 0 до 9
     по умолчанию используется таймер с номером 0
    }
    function timerStart(ID:integer=0):TEv3;
    {
     возвращает кол-во миллисекунд с момента запуска таймера
    }
    function timer(ID:integer=0):dword;
    function timer(ID:integer; out ms:dword):TEv3;
    { 
     блокирует на таймаут ms с момента старта таймера
     например: timerStart(8) выполнен в 13:05:23
     если timerWait(6000,8) запущен в 13:05:25,
     то блокировка по 8 таймеру закончится 13:05:29
     если timerWait(6000,8) запущен после 13:05:29,
     то произойдет немедленный выход из функции.
    }
    function timerWait(ms:dword; ID:integer=0):TEv3;
  end;

var ev3:TEv3=nil;
  // вызов инициализции всех модулей.
  // перехват сигналов завершения работы (INT, ABRT, QUIT) с вызовом ev3Done
  procedure ev3Init();
  procedure ev3Init(links:array of const);
  procedure ev3Init(signal:string);
  procedure ev3Init(signal:string; links:array of const);

type
  TInitProc=procedure;
  TDoneProc=procedure;
  // модуль, желающий инициализации, должен вызвать pushInit
  procedure PushInit(proc:tinitproc);
  // модуль, желающий инициализации, должен вызвать pushDone
  procedure PushDone(proc:tdoneproc);


var ev3finalized:boolean=false; // истина, если сейчас идет завершение работы
{
  // набор предопределенных переменных для произвольного использования
  var a,a0,a1,a2,a3,a4,a5,a6,a7,a8,a9:variant;
  var b,b0,b1,b2,b3,b4,b5,b6,b7,b8,b9:variant;
  var c,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9:variant;
  var d,d0,d1,d2,d3,d4,d5,d6,d7,d8,d9:variant;
  var e,e0,e1,e2,e3,e4,e5,e6,e7,e8,e9:variant;
  var f,f0,f1,f2,f3,f4,f5,f6,f7,f8,f9:variant;
  var g,g0,g1,g2,g3,g4,g5,g6,g7,g8,g9:variant;
  var h,h0,h1,h2,h3,h4,h5,h6,h7,h8,h9:variant;
  var i,i0,i1,i2,i3,i4,i5,i6,i7,i8,i9:variant;
  var j,j0,j1,j2,j3,j4,j5,j6,j7,j8,j9:variant;
  var k,k0,k1,k2,k3,k4,k5,k6,k7,k8,k9:variant;
  var l,l0,l1,l2,l3,l4,l5,l6,l7,l8,l9:variant;
  var m,m0,m1,m2,m3,m4,m5,m6,m7,m8,m9:variant;
  var n,n0,n1,n2,n3,n4,n5,n6,n7,n8,n9:variant;
  var o,o0,o1,o2,o3,o4,o5,o6,o7,o8,o9:variant;
  var p,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9:variant;
  var q,q0,q1,q2,q3,q4,q5,q6,q7,q8,q9:variant;
  var r,r0,r1,r2,r3,r4,r5,r6,r7,r8,r9:variant;
  var s,s0,s1,s2,s3,s4,s5,s6,s7,s8,s9:variant;
  var t,t0,t1,t2,t3,t4,t5,t6,t7,t8,t9:variant;
  var u,u0,u1,u2,u3,u4,u5,u6,u7,u8,u9:variant;
  var v,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9:variant;
  var w,w0,w1,w2,w3,w4,w5,w6,w7,w8,w9:variant;
  var x,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9:variant;
  var y,y0,y1,y2,y3,y4,y5,y6,y7,y8,y9:variant;
  var z,z0,z1,z2,z3,z4,z5,z6,z7,z8,z9:variant;
}

 procedure ev3Done;
 //procedure ev3Link(port:variant; typedev:variant);
implementation

uses
  SysUtils,BaseUnix,unix,dateutils,uev3func,uev3utf8,uev3devices,
  rubiroLeds,rubiroSound,rubiroScreen,rubiroButtons;

var systemEHandler:TExceptProc;
procedure ev3EHandler(Obj: TObject; Addr: CodePointer; FrameCount: LongInt; Frame: PCodePointer);
begin
  fpsystem('beep -f 300 -n -f 100 -n -f 200');
  if assigned(systemEHandler) then systemEHandler(Obj,Addr,FrameCount,Frame);
end;

var iProcs:array[0..500] of TInitProc;
    iCount:integer=0;
    dProcs:array[0..500] of TDoneProc;
    dCount:integer=0;


type TThreadRec=record
      stop:boolean;
     end;

var killCount:integer=0;
    killTR:TThreadRec;
    killThread:TThreadID;

function killBack(p:pointer):ptrint;
begin
 result:=0;
 while killcount<20 do begin
  if TThreadRec(p^).stop then exit;
  if ev3buttons.Back then inc(killcount)
  else killcount:=0;
  sleep(100);
 end;
 fpkill(fpgetpid(), SIGINT);
end;


procedure ev3Done;
 var i:integer;
begin
 killTR.stop:=true;
// writeln('term1');
 WaitForThreadTerminate(killThread,0);
// writeln('term2');
 if ev3Finalized then exit;
 ev3Finalized:=true;
 for i:=dCount-1 downto 0 do begin
   try
    dprocs[i]();
   except
   end;
 end;
 ev3.free;
end;

Procedure Finish(sig : cint);cdecl;
begin
 // writeln('Выход по сигналу ',sig);
 //ev3sound.beep(100);
 ev3Done();
 fpkill(fpgetpid(), sig);
end;



//----------------------------------------
{
 Процедура привязки устройств к портам.
 В случае неверного определения устройства на соответствующем порту
 пытается принудительно его установить//, если Ignore=false (по умолчанию)
}
function ev3Link(port:tEv3Port; typedev:TEv3DeviceType):boolean;
  var dev:TEv3Device;
      fd:TEv3DeviceFactory;
 begin
  result:=true;
   fd:=ev3deviceFactory;
   dev:=fd.Devices[port];
   if assigned(dev) and (dev.connected) and (dev.Device=typedev) then exit; // нормально
   result:=false;
 end;



procedure ev3Init(links:array of const);
 var i:longint; errors,ecount:integer; eports:string;
     ports:array[1..8] of TEv3Port;
     devts:array[1..8] of TEv3DeviceType;
     devt:TEv3DeviceType;
     port:tEv3Port;
     devp:TEv3Device; // устройство - порт
begin
  ev3init;
  eports:='';
  i:=0; errors:=0;
  while i<=High(links) do begin
    port:=TEv3DeviceHelper.varToPort(arg2string(links[i]));
    devt:=TEv3DeviceHelper.varToDevice(arg2string(links[i+1]));
    if not ev3link(port,devt) then begin
      inc(errors);
      devts[errors]:=devt;
      ports[errors]:=port;
      eports+=' '+inttostr(ord(port));
    end;
    inc(i,2);
  end;
  if errors=0 then exit;
  // ошибки найдены, исправляем
  doneDeviceFactory;
  for i:=1 to errors do begin
   devt:=devts[i];
   devp:=ev3PortFactory.devices[ports[i]];
   if ev3IDS[devt].PortMode<>'' then devp.Attrs[ev3amode].hardPutData(ev3IDS[devt].PortMode);
   if ev3IDS[devt].PortSetDevice<>'' then devp.Attrs[ev3aset_device].hardPutData(ev3IDS[devt].PortSetDevice);
  end;
  ev3screen.clear
           .fontSize(10)
           .print(0,20,'Ошибка устройств!')
           .print(0,40,'Порт(ы): '+eports)
           .print(0,60,'Пытаюсь исправить ...')
           .show;
 // ждем подьема девайсов, пищим
 while true do begin
  ev3sound.beep(3000).wait;
  initDeviceFactory;
  ecount:=0;
  for i:=1 to errors do if not ev3link(ports[i],devts[i]) then inc(ecount);
  if ecount=0 then break;
  doneDeviceFactory;
 end;
end;

procedure ev3Init(signal: string);
begin
  ev3init();
  startProcess('beep '+signal);
end;

procedure ev3Init(signal: string; links: array of const);
begin
 ev3Init(links);
 startProcess('beep '+signal);
end;


Var
   na : SigActionRec;

procedure ev3Init;
 var i:integer;
begin
 systemEHandler:=ExceptProc;
 ExceptProc:=@ev3EHandler;
 ev3:=TEv3.Create;
 for i:=0 to iCount-1 do begin
  iprocs[i]();
 end;

 na.sa_Handler:=SigActionHandler(@Finish);
 fillchar(na.Sa_Mask,sizeof(na.sa_mask),#0);
 na.Sa_Flags:=SA_RESETHAND;
 na.Sa_Restorer:=Nil;
 fpSigAction(SIGINT,@na,nil);
 fpSigAction(SIGABRT,@na,nil);
 fpSigAction(SIGQUIT,@na,nil);
 fpSigAction(SIGTERM,@na,nil);
 fpSigAction(SIGHUP,@na,nil);
 killThread:=BeginThread(@killBack,@killTR);
end;


procedure PushInit(proc: tinitproc);
begin
  iprocs[icount]:=proc;
  inc(icount);
end;

procedure PushDone(proc: tdoneproc);
begin
  dprocs[dCount]:=proc;
  inc(dCount);
end;

{ TEv3 }

function TEv3.waitEvents(Args: array of const; eLink: TEv3EventLink; out res:TEv3; timeout: dword=high(dword)): boolean;
 var o:array of TEv3; e:array of string;
     i,k:integer;
     R:TEv3;
begin
  res:=nil;
  if High(Args)<2 then exit(false);
  setlength(o,(High(Args)+1) div 2);
  setlength(e,(High(Args)+1) div 2);
  i:=0;k:=0;
  while i<High(Args) do begin
    o[k]:=arg2Obj(args[i]) as TEv3;
    e[k]:=arg2String(args[i+1]);
    //writeln(o[i].classname,' - ',arg2String(args[i+1]));
    inc(i,2);
    inc(k);
  end;
//  for i:=0 to length(e)-1 do writeln(o[i].classname,' + ',e[i]);
  result:=self.waitEvents(o,e,elink,R,timeout);
  res:=R;
end;

function TEv3.waitEvents(Objs: array of TEv3; Events: array of string;
  eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
var
    allYes,yes:boolean;
    i:integer;
    cnt:integer;
begin
 cnt:=0;
 try
  timerStart();
  while true do begin
    inc(cnt); if cnt>20 then begin cnt:=0; ev3Leds.blink; end;
    allYes:=true;
    for i:=0 to length(objs)-1 do begin
      yes:=objs[i].waitEvent(events[i],0);
      if (eLink=evOr) and yes then begin
       // writeln('-- ',events[i]);
        res:=objs[i];
        exit(true);
      end;
      AllYes:=AllYes and yes;
    end;
    if allyes then exit(true);
    if timer()>=timeout then exit(false);
    sleep(waitInterval);
  end;
 finally
  ev3leds.unblink;
 end;
end;

function TEv3.sleep(ms: dword): TEv3;
begin
  result:=self;
  SysUtils.Sleep(ms);
end;

function TEv3.timerStart(ID: integer): TEv3;
begin
  result:=self;
  ftimers[id]:=now();
end;

function TEv3.timer(ID: integer): dword;
begin
 result:=MilliSecondsBetween(now(),ftimers[id]);
end;

function TEv3.timer(ID: integer; out ms: dword): TEv3;
begin
 result:=self;
 ms:=timer(id);
end;

function TEv3.timerWait(ms: dword; ID: integer): TEv3;
 var tm:dword;
begin
 result:=self;
 tm:=timer(id);
 if tm>ms then exit;
 sleep(ms-tm);
end;

constructor TEv3.Create;
 var i:integer;
begin
  inherited Create;
  for i:=low(ftimers) to high(ftimers) do timerStart(i);
end;

class function TEv3.varToYes(yes: variant): boolean;
begin
 case utf8lowercase(trim(varToStr(yes))) of
  'нет','no','0','':result:=false
  else result:=true;
 end;
end;

function TEv3.waitEvent(event: ansistring; timeout: dword): boolean;
begin
  RunError(65535);
end;

function TEv3.waitAllEvents(objs: array of const; timeout: dword=high(dword)): boolean;
  var res:TEv3;
begin
  result:=waitEvents(objs,evAND,res,timeout);
end;

function TEv3.waitAnyEvent(objs: array of const; timeout: dword=high(dword)): TEv3;
begin
 waitEvents(objs,evOR,result,timeout);
end;

finalization

 ev3Done();
end.

